package didatico.armazenamento.arquivo.exercicios.l06q03;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Questao03ListaArq
{
    public static void main(String args[])
    {
        merge(Questao03ListaArq.class.getResource("cadastro01.txt").getPath(),
              Questao03ListaArq.class.getResource("cadastro02.txt").getPath(),
              Questao03ListaArq.class.getResource("cadastro03.txt").getPath());
    }
    
    public static void merge(String arqe1, String arqe2, String arqs)
    {
        try {
            FileReader f1 = new FileReader(arqe1);
            BufferedReader e1 = new BufferedReader(f1);
            FileReader f2 = new FileReader(arqe2);
            BufferedReader e2 = new BufferedReader(f2);
            FileWriter f3 = new FileWriter(arqs);
            PrintWriter s3 = new PrintWriter(f3);
            
            Funcionario func1 = leRegistro(e1);
            Funcionario func2 = leRegistro(e2);
            
            while (func1 != null || func2 != null)
            {
                if (func2 == null ||
                    (func1 != null &&
                     func1.getMatricula().compareTo(func2.getMatricula()) <= 0))
                {
                    gravaRegistro(s3, func1);
                    func1 = leRegistro(e1);
                }
                else
                {
                    gravaRegistro(s3, func2);
                    func2 = leRegistro(e2);
                }
            }
            
            e1.close();
            e2.close();
            s3.close();
            
            System.out.println("Arquivo gerado com sucesso!");
        } catch (IOException erro) {
            erro.printStackTrace();
        }
    }
    
    private static Funcionario leRegistro(BufferedReader entrada)
    {
        Funcionario func = null;
        
        try {
            String matricula = entrada.readLine();
            
            if (matricula != null)
            {
                String nome = entrada.readLine();
                String salario = entrada.readLine();
                
                if (nome != null && salario != null)
                    func = new Funcionario(matricula, nome,
                                           Float.parseFloat(salario));
            }
        } catch (IOException erro) {
            erro.printStackTrace();
        }
        
        return func;
    }
    
    private static void gravaRegistro(PrintWriter saida,
                               Funcionario func)
    {
        saida.println(func.getMatricula());
        saida.println(func.getNome());
        saida.println(func.getSalario());
    }
}
