package didatico.armazenamento.bancodados.lib.example;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import didatico.armazenamento.bancodados.lib.Database;

public class DatabaseExample
{

    public static void main(String args[])
    {
        try {
            Database bd = Database.getInstance();
        
            Connection dbConexao = bd.getConnection();

            executaConsulta(dbConexao);
            
            bd.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    
    public static void executaConsulta(Connection conexao)
    {

        try {
            Statement comando = conexao.createStatement();

            ResultSet resultado = comando.executeQuery(
                "SELECT Titulo, Endereco, Acessos, Categoria FROM Marcadores");

            boolean temConteudo = resultado.next();
            while (temConteudo)
            {
                String titulo = resultado.getString("Titulo"),
                endereco = resultado.getString("Endereco");
                int acessos = resultado.getInt("Acessos");
                String categoria = resultado.getString("Categoria");
                System.out.println(titulo + "; " + endereco + "; " + acessos + "; " + categoria);
                temConteudo = resultado.next();
            }

            comando.close();
        } catch (SQLException erro) {
            erro.printStackTrace();
        }
    }

}