package didatico.armazenamento.bancodados.listaexercicios.lista01;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L01Q01bComTransacao
{
    public static void main(String[] args)
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            lancaVendas(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public static void lancaVendas(Connection conexao)
           throws SQLException
    {
        conexao.setAutoCommit(false);
        
        PreparedStatement comando1 =
            conexao.prepareStatement
                ("INSERT INTO Venda VALUES (?,?)");
        PreparedStatement comando2 =
            conexao.prepareStatement
                ("INSERT INTO ItemVenda VALUES (?,?,?)");
        PreparedStatement comando3 =
            conexao.prepareStatement
                ("UPDATE Produto " +
                        "SET SaldoEstoque = SaldoEstoque - ? " +
                        "WHERE Nome = ?");

        Scanner entrada = new Scanner(System.in);
        
        System.out.print("Digite Numero da Venda ou FIM: ");
        String numeroVenda = entrada.nextLine();
        
        while (!numeroVenda.equalsIgnoreCase("FIM"))
        {
            System.out.print("Digite a data (aaaa-mm-dd): ");
            String dataVenda = entrada.nextLine();
            
            comando1.setString(1, numeroVenda);
            comando1.setDate(2, Date.valueOf(dataVenda));    
                
            comando1.executeUpdate();
            
            System.out.print("Digite o nome do produto ou CONCLUI: ");
            String nomeProduto = entrada.nextLine();
            
            while (!nomeProduto.equalsIgnoreCase("CONCLUI"))
            {
                System.out.print("Digite a quantidade: ");
                String quantStr = entrada.nextLine();
                float quantidade = Float.parseFloat(quantStr);
                
                comando2.setString(1, numeroVenda);
                comando2.setString(2, nomeProduto);
                comando2.setFloat(3, quantidade);
                comando2.executeUpdate();
                
                comando3.setFloat(1, quantidade);
                comando3.setString(2, nomeProduto);
                comando3.executeUpdate();
                
                System.out.print("Digite o nome do produto ou CONCLUI: ");
                nomeProduto = entrada.nextLine();
            }
            
            System.out.println("Venda realizada com sucesso!\n");
            
            conexao.commit();
            
            System.out.print("Digite Numero da Venda ou FIM: ");
            numeroVenda = entrada.nextLine();
        }
        
        comando1.close();
        comando2.close();
        comando3.close();
        
        conexao.setAutoCommit(true);
    }
}
