package didatico.armazenamento.bancodados.listaexercicios.lista01;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L01Q01dSemTransacao
{
    public static void main(String args[])
    {
        Database banco;
        try {
            banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            venda(conexao);
            
            System.out.println("*** Programa finalizado");
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }

    }
    
    public static void venda(Connection conexao) throws SQLException
    {
        PreparedStatement comandoVenda =
            conexao.prepareStatement(
                    "INSERT INTO Venda VALUES(?,?)");

        Scanner teclado = new Scanner(System.in);
       
        String numeroVenda;
        do {
            System.out.println("=====");
            System.out.println("Venda");
            System.out.println("=====");
            
            System.out.print("Digite o numero: ");
            numeroVenda = teclado.nextLine();
            
            if (numeroVenda.length() != 0)
            {
                System.out.print("Digite a data (aaaa-mm-dd): ");
                Date dataVenda = Date.valueOf(teclado.nextLine());
                
                comandoVenda.setString(1, numeroVenda);
                comandoVenda.setDate(2, dataVenda);
                
                comandoVenda.executeUpdate();
                
                itensVenda(conexao, numeroVenda);
                
                System.out.println("*** Venda realizada");
                System.out.println();
            }
        } while (numeroVenda.length() != 0);
        
        comandoVenda.close();
    }
    
    public static void itensVenda(Connection conexao,
                                  String numeroVenda) throws SQLException
    {
        Scanner teclado = new Scanner(System.in);
        
        PreparedStatement comandoItem =
            conexao.prepareStatement(
                    "INSERT INTO ItemVenda VALUES(?,?,?)");
        
        PreparedStatement comandoSaldo =
            conexao.prepareStatement(
                    "UPDATE Produto " +
                           "SET SaldoEstoque = SaldoEstoque - ? "+
                           "WHERE Nome = ?");
        
        String nomeProduto;
        do {
            System.out.println();
            System.out.println("-------------");
            System.out.println("Item de Venda");
            System.out.println("-------------");
            
            System.out.print("Nome do produto: ");
            nomeProduto = teclado.nextLine();
            
            if (nomeProduto.length() != 0)
            {
                System.out.print("Quantidade: ");
                int quantidade = Integer.parseInt(teclado.nextLine());
                
                comandoItem.setString(1, numeroVenda);
                comandoItem.setString(2, nomeProduto);
                comandoItem.setInt(3, quantidade);
                comandoItem.executeUpdate();
                
                comandoSaldo.setString(2, nomeProduto);
                comandoSaldo.setInt(1, quantidade);
                comandoSaldo.executeUpdate();
            }
        } while (nomeProduto.length() != 0);
        
        comandoItem.close();
        comandoSaldo.close();
    }
}
