package didatico.armazenamento.bancodados.listaexercicios.lista01;

import java.io.IOException;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L01Q01eSemTransacao
{
    public static void main(String args[])
    {
        
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            venda(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    
    public static void venda(Connection conexao) throws SQLException
    {
        Scanner teclado = new Scanner(System.in);
        
        String numeroVenda;
        
        PreparedStatement comandoVenda = 
            conexao.prepareStatement(
                    "INSERT INTO Venda VALUES(?,?)");
        
        do {
            System.out.println("=====");
            System.out.println("Venda");
            System.out.println("=====");
            
            System.out.print("Numero nota: ");
            numeroVenda = teclado.nextLine();
            
            if (numeroVenda.length() > 0)
            {
                System.out.print("Data venda (aaaa-mm-dd): ");
                Date dataVenda = Date.valueOf(teclado.nextLine());
                
                comandoVenda.setString(1, numeroVenda);
                comandoVenda.setDate(2, dataVenda);
                
                comandoVenda.executeUpdate();
                
                itensVenda(conexao, numeroVenda);
            }
            
            System.out.println();
        } while (numeroVenda.length() > 0);
        
        comandoVenda.close();
        
        System.out.println("Programa finalizado");
    }
    
    public static void itensVenda(Connection conexao,
                                  String numeroVenda) throws SQLException
    {
        Scanner teclado = new Scanner(System.in);
        
        PreparedStatement comandoItem =
            conexao.prepareStatement(
                    "INSERT INTO ItemVenda VALUES (?,?,?)");
        PreparedStatement comandoSaldo =
            conexao.prepareStatement(
                    "UPDATE Produto " +
                           "SET SaldoEstoque = SaldoEstoque - ? " +
                           "WHERE Nome = ?");
        
        String nomeProduto;
        
        do {
            System.out.println("----------");
            System.out.println("Item Venda");
            System.out.println("----------");
            
            System.out.print("Nome do produto: ");
            nomeProduto = teclado.nextLine();
            
            if (nomeProduto.length() > 0)
            {
                System.out.print("Quantidade: ");
                float quantidade = Float.parseFloat(teclado.nextLine());
                
                comandoItem.setString(1, numeroVenda);
                comandoItem.setString(2, nomeProduto);
                comandoItem.setFloat(3, quantidade);
                
                comandoSaldo.setFloat(1, quantidade);
                comandoSaldo.setString(2, nomeProduto);
                
                comandoItem.executeUpdate();
                comandoSaldo.executeUpdate();
            }
            
            System.out.println();
        } while (nomeProduto.length() > 0);
        
        comandoItem.close();
        comandoSaldo.close();
    }
}
