package didatico.armazenamento.bancodados.listaexercicios.lista01;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import didatico.armazenamento.bancodados.lib.Database;

public class L01Q03
{

    public static void main(String[] args)
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            totalizaProdutos(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public static void totalizaProdutos(Connection conexao)
           throws SQLException
    {
        Statement comando = conexao.createStatement();
        ResultSet resultado = comando.executeQuery(
            "SELECT P.Nome, SUM(I.Quantidade) AS Quant, " +
                "SUM(I.Quantidade) * P.PrecoUnitario AS Valor " +
                "FROM ItemVenda I, Produto P " +
                "WHERE I.NomeProduto = P.Nome " +
                "GROUP BY I.NomeProduto");
        
        while (resultado.next()) {
            String nome = resultado.getString("Nome");
            float quantidade = resultado.getFloat("Quant");
            float valor = resultado.getFloat("Valor");
            
            System.out.println("Nome: " + nome + "; " +
                               "Quantidade: " + quantidade + "; " +
                               "Valor: " + valor); 
        }
        
        comando.close();
    }

}
