package didatico.armazenamento.bancodados.listaexercicios.lista01;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import didatico.armazenamento.bancodados.lib.Database;

public class L01Q05
{
    public static void main(String[] args)
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            relatorioVendas(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public static void relatorioVendas(Connection conexao)
           throws SQLException
    {
        Statement comando = conexao.createStatement();
        ResultSet resultado = comando.executeQuery(
            "SELECT I.NomeProduto, V.Numero, V.DataVenda, I.Quantidade " +
                    "FROM Venda V, ItemVenda I " +
                    "WHERE V.Numero = I.NumeroVenda " +
                    "ORDER BY I.NomeProduto, V.DataVenda");
        
        String produtoAnterior = "";
        while (resultado.next())
        {
            String produtoAtual = resultado.getString("NomeProduto");
            if (!produtoAtual.equalsIgnoreCase(produtoAnterior)) {
                System.out.println(produtoAtual);
                produtoAnterior = produtoAtual;
            }
            System.out.print("    " + resultado.getString("Numero") + "  ");
            System.out.print(resultado.getDate("DataVenda") + "  ");
            System.out.println(resultado.getFloat("Quantidade") + "  ");
        }
        
        comando.close();
    }
}
