package didatico.armazenamento.bancodados.listaexercicios.lista02;

import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L02Q01_1b
{
    public static void main(String[] args)
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            executaProcedure(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    /**
     * Chama Stored Procedure:
     *     CREATE PROCEDURE valorProdutoEstoqueA(nomeProduto VARCHAR(80),
     *                                           OUT valorProduto FLOAT)
     *         SELECT SaldoEstoque*PrecoUnitario INTO valorProduto
     *                FROM Produto
     *                WHERE Nome = nomeProduto; 
     *                        
     * @param dbConexao conexao para um banco de dados
     * @throws SQLException
     */
    public static void executaProcedure(Connection conexao)
           throws SQLException
    {
        CallableStatement comando = 
            conexao.prepareCall("{CALL valorProdutoEstoqueB(?,?)}");
        
        Scanner teclado = new Scanner(System.in);
        System.out.print("Digite nome do produto: ");
        String nomeProduto = teclado.nextLine();
        
        comando.setString(1, nomeProduto);
        comando.registerOutParameter(2, Types.FLOAT);
        comando.execute();
        
        System.out.println("Valor do produto em estoque: " +
                           comando.getString(2));
        
        comando.close();
    }
}
