package didatico.armazenamento.bancodados.listaexercicios.lista02;

import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L02Q01_1c
{
    public static void main(String[] args)
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            executaFunction(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    /**
     * Chama Stored Function:
     *     DELIMITER |
     *     CREATE FUNCTION valorProdutoEstoqueC(nomeProduto VARCHAR(80))
     *                     RETURNS FLOAT
     *     BEGIN
     *         DECLARE valorProduto FLOAT;
     *         SELECT SaldoEstoque*PrecoUnitario INTO valorProduto
     *                FROM Produto
     *                WHERE Nome = nomeProduto;
     *         RETURN valorProduto;
     *     END|
     *     
     * @param dbConexao conexao para um banco de dados
     * @throws SQLException
     */
    public static void executaFunction(Connection conexao)
           throws SQLException
    {
        CallableStatement comando = 
            conexao.prepareCall("{? = CALL valorProdutoEstoqueC(?)}");
        
        Scanner teclado = new Scanner(System.in);
        System.out.print("Digite nome do produto: ");
        String nomeProduto = teclado.nextLine();
        
        comando.setString(2, nomeProduto);
        comando.registerOutParameter(1, Types.FLOAT);
        comando.execute();
        
        System.out.println("Valor do produto em estoque: " +
                           comando.getString(1));
        
        comando.close();
    }
}
