package didatico.armazenamento.bancodados.listaexercicios.lista03;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import didatico.armazenamento.bancodados.lib.Database;

public class L03Q01
{
    public static void main(String argumentos[])
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            verificaInvasoes(conexao);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public static void verificaInvasoes(Connection conexao)
           throws SQLException
    {
        Statement comandoSelect = conexao.createStatement();
        
        PreparedStatement comandoInsert = conexao.prepareStatement(
            "INSERT INTO INVASOES VALUES (?, ?)");
        PreparedStatement comandoUpdate = conexao.prepareStatement(
            "UPDATE USUARIOS " +
                   "SET ContaAtiva = FALSE " +
                   "WHERE Identificacao = ?");
        
        ResultSet resultado = comandoSelect.executeQuery(
            "SELECT U.Identificacao, COUNT(*) AS Tentativas " +
                "FROM Usuarios U, LogEntrada L " +
                "WHERE U.Identificacao = L.IdentificacaoDigitada AND " +
                      "U.Senha <> L.SenhaDigitada " +
                "GROUP BY U.Identificacao " +
                "HAVING COUNT(*) > 3");
        
        while (resultado.next())
        {
            String identificacao = resultado.getString("Identificacao");
            int tentativas = resultado.getInt("Tentativas");
            
            System.out.println("Identificacao: " + identificacao);
            System.out.println("Tentativas: " + tentativas);
            
            comandoInsert.setString(1, identificacao);
            comandoInsert.setInt(2, tentativas);
            comandoInsert.executeUpdate();
            
            comandoUpdate.setString(1, identificacao);
            comandoUpdate.executeUpdate();
        }
        
        comandoSelect.close();
        comandoInsert.close();
        comandoUpdate.close();
    }
}
