package didatico.armazenamento.bancodados.listaexercicios.lista04;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L04Q01
{
    public static void main(String argumentos[])
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            Scanner teclado = new Scanner(System.in);
            System.out.print("Digite o nome da disciplina: ");
            String nomeDisciplina = teclado.nextLine();
            
            registraAprovadosFinal(conexao, nomeDisciplina);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public static void registraAprovadosFinal(Connection conexao,
                                              String nomeDisciplina)
           throws SQLException
    {
        conexao.setAutoCommit(false);
        
        PreparedStatement comandoSelect = conexao.prepareStatement(
                "SELECT Al.Nome, SUM(Av.Nota)/Count(*) AS Media " +
                "FROM Aluno Al, Avaliacao Av " +
                "WHERE Al.Matricula = Av.MatriculaAluno AND " +
                      "Av.NomeDisciplina = ? " +
                "GROUP BY Al.Matricula");
        
        PreparedStatement comandoInsertAp = conexao.prepareStatement(
                "INSERT INTO Aprovados VALUES (?, ?)");
        PreparedStatement comandoInsertPF = conexao.prepareStatement(
                "INSERT INTO ProvaFinal VALUES (?, ?)");
        
        comandoSelect.setString(1, nomeDisciplina);
        ResultSet rs = comandoSelect.executeQuery();
        
        while (rs.next())
        {
            String nome = rs.getString("Nome");
            float media = rs.getFloat("Media");
            
            if (media >= 7)
            {
                comandoInsertAp.setString(1, nome);
                comandoInsertAp.setFloat(2, media);
                comandoInsertAp.executeUpdate();
            } else if (media >= 4) {
                comandoInsertPF.setString(1, nome);
                comandoInsertPF.setFloat(2, media);
                comandoInsertPF.executeUpdate();
            }
        }
        
        comandoSelect.close();
        comandoInsertAp.close();
        comandoInsertPF.close();
        
        conexao.commit();
        conexao.setAutoCommit(true);
        
        System.out.println("Medias calculadas e gravadas");
    }
}