package didatico.armazenamento.bancodados.listaexercicios.lista04;

import java.io.IOException;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Scanner;

import didatico.armazenamento.bancodados.lib.Database;

public class L04Q02
{
    public static void main(String argumentos[])
    {
        try {
            Database banco = Database.getInstance();
            Connection conexao = banco.getConnection();
            
            Scanner teclado = new Scanner(System.in);
            System.out.print("Digite titulo da receita: ");
            String titulo = teclado.nextLine();
            System.out.print("Digite quantidade: ");
            float quantidade = Float.parseFloat(teclado.nextLine());
            
            verificaIngredientes(conexao, titulo, quantidade);
            
            banco.releaseConnection();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    /*
     * Stored Procedure:
     * CREATE PROCEDURE consultaQuantidade(nomeProduto VARCHAR(50),
     *                                     OUT quantidade FLOAT)
     *     SELECT QuantidadeEstoque INTO quantidade
     *            FROM ProdutoReceita
     *            WHERE Nome = nomeProduto
     */
    public static void verificaIngredientes(Connection conexao,
                                            String titulo,
                                            float quantidadeTotal)
           throws SQLException
    {
        PreparedStatement comandoSelect = conexao.prepareStatement(
                "SELECT I.NomeProduto, I.QuantidadeIngrediente " +
                       "FROM Receita R, IngredienteReceita I " +
                       "WHERE R.Codigo = I.CodigoReceita AND " +
                             "R.Titulo = ?");
        comandoSelect.setString(1, titulo);
        ResultSet rs = comandoSelect.executeQuery();
        
        CallableStatement comandoProcedure = conexao.prepareCall(
                "{CALL consultaQuantidade(?, ?)}");
        comandoProcedure.registerOutParameter(2, Types.FLOAT);
        
        while (rs.next())
        {
            String nomeProduto = rs.getString("NomeProduto");
            float quantidadeIngr = rs.getFloat("QuantidadeIngrediente");
            
            float totalIngr = quantidadeIngr * quantidadeTotal;
            
            comandoProcedure.setString(1, nomeProduto);
            comandoProcedure.execute();
            float totalEstoque = comandoProcedure.getFloat(2);
            
            if (totalIngr > totalEstoque)
                System.out.println("Comprar ingrediente " + nomeProduto +
                                   "; quantidade: " + (totalIngr - totalEstoque));
        }
        
        comandoSelect.close();
        comandoProcedure.close();
    }
}
