package didatico.armazenamento.bancodados.pack07storedprocedure.exercicio;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Types;

public class Exercicio01
{
    public static void main(String argumentos[])
    {

        try {
            Class.forName("org.gjt.mm.mysql.Driver");
            Connection conexao = DriverManager.getConnection("jdbc:mysql://localhost:3306/sala", "root", "thelab");

            executaStoredProcedure(conexao);

            conexao.close();
        } catch (ClassNotFoundException erro) {
            System.out.println(erro.getMessage());
        } catch (SQLException erro) {
            System.out.println("Erro no SQL: " + erro.getMessage());
        }
    }
    
    /**
     * Chama a seguinte stored procedure:
     *     DELIMITER |
     *     CREATE FUNCTION numeroCorridas(
     *         dataContagem DATE) RETURNS INTEGER
     *     BEGIN
     *         DECLARE numero INTEGER;
     *         SELECT Count(*) INTO numero FROM Corrida
     *                WHERE DataPedido = dataContagem;
     *         RETURN numero;
     *     END|
     * 
     * @param dbConexao
     * @throws SQLException
     */
    public static void executaStoredProcedure(Connection dbConexao) throws SQLException
    {
        CallableStatement comando = dbConexao.prepareCall("{ ? = call numeroCorridas(?) }");
        comando.registerOutParameter(1, Types.INTEGER);
        comando.setDate(2, new Date(System.currentTimeMillis()));
        comando.execute();
        
        System.out.println("O numero de corridas em " + new Date(System.currentTimeMillis()) + " dia eh: " + comando.getInt(1));
        
        comando.close();
    }
}
