/*
 * Created on 15/04/2005
 *
 */
package didatico.componente.sistema.reference.test;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import didatico.componente.sistema.dbframe.Database;

/**
 * @author Simone Almeida Chaves Santanch
 *
 */
public class DatabaseTest
{
    private static PrintStream output = null;
    
    public static void main(String args[])
    {
        // define log output
        output = System.out;
        if (args.length > 0)
            try {
                output = new PrintStream(new File(args[0]));
            } catch (IOException e) {
                output = System.out;
            }
        
        output.println("Getting connection...");
        try {
            Connection conn = Database.getConnection();
            
            if (conn != null) {
                output.println("Database connected.");
                
                tableTest(conn);
                
                output.println("Closing connection...");
                Database.closeConnection();
                output.println("Connection closed.");
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
    
    private static void tableTest(Connection conn)
    {
        output.println("------------------------------");
        output.println("Table Test");
        output.println("------------------------------");
        
        try {
            Statement stat = conn.createStatement();
            
            if (stat == null)
                output.println("Statement null.");
            else
            {
                ResultSet result = stat.executeQuery("SELECT * FROM PERSON");
                if (result == null)
                    output.println("PERSON ResultSet null");
                else {
                    output.println("PERSON results:");
                    boolean hasNext = result.next();
                    while (hasNext) {
                        output.println("id: " + result.getString("PERSON_ID") + "; " +
                                       "name: " + result.getString("NAME") + "; " +
                                       "password: " + result.getString("PASSWORD"));
                        hasNext = result.next();
                    }
                }
                stat.close();
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }
        output.println("------------------------------");
    }
}
